// The Observer
function Observer() {
	//method
	this.update = function() {
		// ...
	};
}

function ObserverList() {
	//members
	this.observerList = [];
	//methods
	this.add = function(obj) {
  		return this.observerList.push(obj);
	};

	this.empty = function() {
  		this.observerList = [];
	};

	this.count = function() {
  		return this.observerList.length;
	};
		
	this.get = function(index) {
  		if(index > -1 && index < this.observerList.length) {
			return this.observerList[ index ];
  		}
	};

	this.insert = function(obj, index) {
  		var pointer = -1;

		if(index === 0) {
			this.observerList.unshift(obj);
			pointer = index;
  		} else if(index === this.observerList.length) {
			this.observerList.push(obj);
			pointer = index;
  		}

	  	return pointer;
	};

	this.indexOf = function(obj, startIndex) {
  		var i = startIndex, pointer = -1;

		while(i < this.observerList.length) {
			if(this.observerList[i] === obj) {
	  			pointer = i;
			}
			i++;
  		}
		return pointer;
	};

	this.removeAt = function(index) {
		if(index === 0) {
			this.observerList.shift();
  		} else if(index === this.observerList.length -1) {
			this.observerList.pop();
  		}
	};
}

// Extend an object with an extension
function extend(extension, obj) {
	for (var key in extension) {
		obj[key] = extension[key];
	}
}
 
function Subject() {
	//members
	this.observers = new ObserverList();
	
	//methods
	this.addObserver = function(observer) {
 		this.observers.add(observer);
	};  

	this.removeObserver = function(observer) {
		this.observers.removeAt(this.observers.indexOf(observer, 0));
	};  

	this.notify = function(context) {
		var observerCount = this.observers.count();
  		for(var i=0; i < observerCount; i++) {
			this.observers.get(i).update(context);
  		}
	};
}